## icon 9.4.3

=== Makefile ===
#  Makefile for Version 9.4 of Icon
#
#  See doc/install.htm for instructions.


#  configuration parameters
VERSION=v943
name=unspecified
csw=custom
dest=/must/specify/dest/


##################################################################
#
# Default targets.

All:	Icont Ilib Ibin

config/$(name)/status src/h/define.h:
	:
	: To configure Icon, run either
	:
	:	make Configure name=xxxx     [for no graphics]
	: or	make X-Configure name=xxxx   [with X-Windows graphics]
	:
	: where xxxx is one of
	:
	@cd config; ls -d `find * -type d -prune -print`
	:
	@exit 1


##################################################################
#
# Code configuration.


# Configure the code for a specific system.

Configure:	config/$(name)/status
		$(MAKE) Pure >/dev/null
		cd config; sh setup.sh $(name) NoGraphics $(csw)

X-Configure:	config/$(name)/status
		$(MAKE) Pure >/dev/null
		cd config; sh setup.sh $(name) Graphics $(csw)


# Get the status information for a specific system.

Status:
		@cat config/$(name)/status


##################################################################
#
# Compilation.


# The interpreter: icont and iconx.

Icont bin/icont: Common
		cd src/icont;		$(MAKE)
		cd src/runtime;		$(MAKE) 


# The compiler: rtt, the run-time system, and iconc.
# (NO LONGER SUPPORTED OR MAINTAINED.)

Iconc bin/iconc: Common
		cd src/runtime;		$(MAKE) comp_all
		cd src/iconc;		$(MAKE)


# Common components.

Common:		src/h/define.h
		cd src/common;		$(MAKE)
		cd src/rtt;		$(MAKE)


# The Icon program library.

Ilib:		bin/icont
		cd ipl;			$(MAKE) Ilib

Ibin:		bin/icont
		cd ipl;			$(MAKE) Ibin


##################################################################
#
# Installation and packaging.


# Installation:  "make Install dest=new-icon-directory"

D=$(dest)
Install:
		mkdir $D
		mkdir $D/bin $D/lib $D/doc $D/man $D/man/man1
		cp README $D
		cp bin/[cflpvwx]* $D/bin
		cp bin/icon[tx]* $D/bin
		rm -f $D/bin/libI*
		(cd $D/bin; ln -s icont icon)
		cp lib/*.* $D/lib
		cp doc/*.* $D/doc
		cp man/man1/*.* $D/man/man1


# Bundle up for binary distribution.

DIR=icon.$(VERSION)
Package:
		rm -rf $(DIR)
		umask 002; $(MAKE) Install dest=$(DIR)
		tar cf - icon.$(VERSION) | gzip -9 >icon.$(VERSION).tgz
		rm -rf $(DIR)


##################################################################
#
# Tests.

Test    Test-icont:	; cd tests; $(MAKE) Test
Samples Samples-icont:	; cd tests; $(MAKE) Samples

Test-iconc:		; cd tests; $(MAKE) Test-iconc
Samples-iconc:		; cd tests; $(MAKE) Samples-iconc


#################################################################
#
# Run benchmarks.

Benchmark:
		$(MAKE) Benchmark-icont

Benchmark-iconc:
		cd tests/bench;		$(MAKE) benchmark-iconc

Benchmark-icont:
		cd tests/bench;		$(MAKE) benchmark-icont


##################################################################
#
# Cleanup.
#
# "make Clean" removes intermediate files, leaving executables and library.
# "make Pure"  also removes binaries, library, and configured files.

Clean:
		touch Makedefs
		rm -rf icon.*
		cd src;			$(MAKE) Clean
		cd ipl;			$(MAKE) Clean
		cd tests;		$(MAKE) Clean

Pure:
		touch Makedefs
		rm -rf icon.*
		rm -rf bin/[abcdefghijklmnopqrstuvwxyz]*
		rm -rf lib/[abcdefghijklmnopqrstuvwxyz]*
		cd ipl;			$(MAKE) Pure
		cd src;			$(MAKE) Pure
		cd tests;		$(MAKE) Pure
		cd config; 		$(MAKE) Pure



#  (This is used at Arizona to prepare source distributions.)

Dist-Clean:
		rm -rf xx `find * -type d -name CVS`
		rm -f  xx `find * -type f | xargs grep -l '<<ARIZONA-[O]NLY>>'`

=== config/Makefile ===
#  Makefile for cleaning up after setup.sh

TOP = ..
SRC = $(TOP)/src


Clean:

Pure:
	rm -f $(TOP)/Makedefs
	rm -f $(SRC)/h/define.h
	rm -f $(SRC)/common/rswitch.[csS]

=== ipl/Makefile ===
#  Makefile for the Icon Program Library


All:	Ilib Ibin


#  Make a library distribution (portable ucode and include files).

Ilib:	cfuncs/libcfunc.so
cfuncs/libcfunc.so:  ../bin/icont
	cp incl/*.icn gincl/*.icn cfuncs/icall.h ../lib
	cd procs;  LPATH= ../../bin/icont -usc *.icn; mv *.u? ../../lib
	cd gprocs; LPATH= ../../bin/icont -usc *.icn; mv *.u? ../../lib
	if grep '^ *# *define LoadFunc' ../src/h/define.h >/dev/null; \
	   then $(MAKE) Cfunctions; fi


#  Make C functions.  Only called if LoadFunc is defined.

Cfunctions:
	cd cfuncs; LPATH= $(MAKE) ICONT=../../bin/icont
	cp cfuncs/*.u? ../lib
	cp cfuncs/libcfunc.so ../bin


#  Make selected graphics program binaries (platform-dependent icode)
#  for ../bin, given that ../lib is ready

Ibin:	gpacks/vib/vib
gpacks/vib/vib:  ../bin/icont
	MAKE=$(MAKE) ./BuildBin


#  Make a full set of program binaries (not usually done) in ./iexe,
#  given that ../lib is ready

Iexe:
	rm -f iexe/*
	MAKE=$(MAKE) ./BuildExe


#  Check for undefined identifiers in ../lib.
#  (A few are expected: references to Mp, program, init, goal).

Undef:
	cd ../lib; for f in *.u2; do (echo $$f; icont -us -fs $$f); done


#  Check for stray files

Strays:
	for d in *procs *progs *incl; do (cd $$d; pwd; gcomp CVS *.icn); done


#  Verify that all procedures and programs build, including packs,
#  and perform some other sanity checks

Check:
	./CheckAll


#  Make Zip files for separate distribution of the library

ZipFiles:  Ilib
	rm -rf ilib *.zip
	zip -qrX9 bipl.zip docs incl procs progs packs data cfuncs -x '*/CVS/*'
	zip -qrX9 gipl.zip gdocs gincl gprocs gprogs gpacks gdata  -x '*/CVS/*'
	zip -qrX9 mipl.zip mincl mprocs mprogs                     -x '*/CVS/*'
	mkdir ilib
	cp ../lib/*.* ilib
	zip -qrX9 ilib.zip ilib
	rm -rf ilib


#  Clean up.

Clean Pure:
	-rm -rf ilib iexe *.zip */*.u[12] */*.zip */*.so
	-rm -f xx `find *procs *progs -type f -perm -100 -print`
	for d in cfuncs *packs/[abcdefghijklmnopqrstuvwxyz]*; do \
	    (cd $$d; $(MAKE) Clean); done

=== src/Makefile ===
#  Icon source Makefile, normally used only for cleanup.


what:
	@echo "What do you want to make?"

Clean Pure:
	cd iconc;	rm -f *.o iconc
	cd common;	rm -f *.o doincl patchstr infer
	cd preproc;	rm -f *.o pp
	cd rtt;		rm -f *.o rtt
	cd runtime;	rm -f *.o *.c rt.db rt.a rttcur.lst rttfull.lst iconx
	cd icont;	rm -f *.o icont hdr.h ixhdr.hdr newhdr
	cd wincap;	rm -f *.o *.a
	cd xpm;		rm -f *.o *.a
# force full runtime system rebuild
	touch h/define.h
	rm -f h/arch.h


#  The following entry forces rebuilding of everthing from first-generation
#  files, even files not normally recreated.  Doing this requires uncommenting
#  some lines in common/Makefile, icont/Makefile, and iconc/Makefile.

Force-rebuild: Clean
	cd h; rm -f kdefs.h
	cd common; rm -f *.o yacctok.h lextab.h icontype.h \
		doincl fixgram mktoktab patchstr pscript typespec
	cd icont; rm -f *.o icont mkkwd trash \
		hdr.h keyword.h tgram.g ttoken.h tparse.c
	cd iconc; rm -f *.o iconc cgram.g ctoken.h cparse.h

=== tests/Makefile ===
#  Makefile for testing Icon


#  The default is to run all tests, using icont.

Test    Test-icont:	; cd general; $(MAKE) Test
Samples Samples-icont:	; cd general; $(MAKE) Samples

Test-iconc:		; cd general; $(MAKE) Test-iconc
Samples-iconc:		; cd general; $(MAKE) Samples-iconc


#  Clean up.

Clean Pure:
	cd bench;	$(MAKE) Clean
	cd general;	$(MAKE) Clean
	cd special;	$(MAKE) Clean

=== ipl/cfuncs/Makefile ===
#  Makefile for the dynamically loaded C function library.
#
#  If building with the compiler (instead of the interpreter)
#  use the "-fs" option to avoid problems.


include ../../Makedefs

ICONT = icont
IFLAGS = -us

FUNCLIB = libcfunc.so

.SUFFIXES: .c .o
.c.o:			; $(CC) $(CFLAGS) $(CFDYN) -c $<

FUNCS = bitcount.o files.o fpoll.o internal.o lgconv.o osf.o \
	pack.o ppm.o process.o tconnect.o
CSRC = $(FUNCS:.o=.c)


default:	cfunc.u2 $(FUNCLIB)


# library

$(FUNCLIB):	$(FUNCS) mklib.sh
		CC="$(CC)" CFLAGS="$(CFLAGS)" sh mklib.sh $(FUNCLIB) $(FUNCS)
$(FUNCS):	icall.h


# Icon interface

cfunc.u2:	cfunc.icn
		$(ICONT) $(IFLAGS) -c cfunc.icn
cfunc.icn:	$(CSRC) mkfunc.sh
		sh mkfunc.sh $(FUNCLIB) $(FUNCS) >cfunc.icn


# cleanup

clean Clean:
		rm -f $(FUNCLIB) *.o *.u? *.so so_locations cfunc.icn

=== src/common/Makefile ===
include ../../Makedefs


OBJS =	long.o getopt.o time.o filepart.o identify.o strtbl.o rtdb.o\
	munix.o literals.o rswitch.o alloc.o long.o getopt.o time.o\
	xwindow.o dlrgint.o ipp.o

common:		doincl $(OBJS) gpxmaybe

doincl:		doincl.c ../h/arch.h
		$(CC) $(CFLAGS) -o doincl doincl.c
		-./doincl -o ../../bin/rt.h ../h/rt.h

patchstr:	patchstr.c
		$(CC) $(CFLAGS) -o patchstr patchstr.c

gpxmaybe:
		-if [ "x$(XL)" != "x" ]; then $(MAKE) $(GDIR); fi

xpm:
		cd ../xpm; $(MAKE) libXpm.a
		cp -p ../xpm/libXpm.a ../../bin/libIgpx.a

wincap:		
		cd ../wincap; $(MAKE) libWincap.a
		cp -u ../wincap/libWincap.a ../../bin/libIgpx.a

$(OBJS): ../h/define.h ../h/arch.h ../h/config.h ../h/cstructs.h \
	  ../h/typedefs.h ../h/mproto.h ../h/cpuconf.h

../h/arch.h:	infer.c
		$(CC) $(CFLAGS) -o infer infer.c
		./infer >../h/arch.h

identify.o: ../h/version.h

ipp.o: ../h/features.h

literals.o: ../h/esctab.h

rtdb.o: ../h/version.h icontype.h

dlrgint.o: ../h/rproto.h ../h/rexterns.h ../h/rmacros.h ../h/rstructs.h

xwindow.o: ../h/graphics.h ../h/xwin.h

#  for rswitch, $(CFLAGS) is deliberately omitted  (-O may cause problems)
rswitch.o: ../h/define.h ../h/arch.h $(RSW)
	$(CC) -c $(RSW)


#  The following section is needed if changes are made to the Icon grammar,
#  but it is not run as part of the normal installation process.  If it is
#  needed, it is run by changing ../icont/Makefile and/or ../iconc/Makefile;
#  see the comments there for details.  icont must be in the search path
#  for this section to work.

gfiles:			lextab.h yacctok.h fixgram pscript

lextab.h yacctok.h:	tokens.txt op.txt mktoktab
			./mktoktab

mktoktab:		mktoktab.icn
			icont -s mktoktab.icn

fixgram:		fixgram.icn
			icont -s fixgram.icn

pscript:		pscript.icn
			icont -s pscript.icn



#  The following section is commented out because it does not need to be
#  performed unless changes are made to typespec.txt. Such changes
#  and are not part of the installation process.  However, if the
#  distribution files are unloaded in a fashion such that their dates
#  are not set properly, the following section would be attempted.
#
#  Note that if any changes are made to the file mentioned above, the
#  comment characters at the beginning of the following lines should be
#  removed.
#
#  Note that icont must be on your search path for this.
#
#
#icontype.h: typespec.txt typespec
#	typespec <typespec.txt >icontype.h
#
#typespec: typespec.icn
#	icont typespec

=== src/iconc/Makefile ===
#  Makefile for the Icon compiler, iconc.
#
#  This is no longer supported and may not work.

include ../../Makedefs


OBJS =		cmain.o ctrans.o dbase.o clex.o\
		cparse.o csym.o cmem.o ctree.o ccode.o ccomp.o\
                ivalues.o codegen.o fixcode.o inline.o chkinv.o\
		typinfer.o types.o lifetime.o incheck.o

COBJS =		../common/long.o ../common/getopt.o ../common/time.o\
		  ../common/filepart.o ../common/identify.o ../common/munix.o\
		  ../common/strtbl.o ../common/rtdb.o ../common/literals.o \
		  ../common/alloc.o ../common/ipp.o



iconc:		$(OBJS) $(COBJS)
		$(CC) -o iconc $(OBJS) $(COBJS)
		cp iconc ../../bin
		strip ../../bin/iconc$(EXE)

$(OBJS):	../h/config.h ../h/cpuconf.h ../h/cstructs.h ../h/define.h\
		../h/mproto.h ../h/typedefs.h ../h/gsupport.h \
		ccode.h cglobals.h cproto.h csym.h ctrans.h ctree.h

$(COBJS):	../h/mproto.h
		cd ../common; $(MAKE); $(MAKE) xpm

ccode.o:	../h/lexdef.h ctoken.h
chkinv.o:	ctoken.h
clex.o:		../h/lexdef.h ../h/parserr.h ctoken.h \
		   ../common/lextab.h ../common/yylex.h ../common/error.h
clocal.o:	../h/config.h
cparse.o:	../h/lexdef.h
ctrans.o:	ctoken.h
ctree.o:	../h/lexdef.h ctoken.h
csym.o:		ctoken.h
dbase.o:	../h/lexdef.h
lifetime.o:	../h/lexdef.h ctoken.h
typinfer.o:	../h/lexdef.h ctoken.h
types.o:	../h/lexdef.h ctoken.h



#  The following sections are commented out because they do not need to
#  be performed unless changes are made to cgrammar.c, ../h/grammar.h,
#  ../common/tokens.txt, or ../common/op.txt.  Such changes involve
#  modifications to the syntax of Icon and are not part of the installation
#  process. However, if the distribution files are unloaded in a fashion
#  such that their dates are not set properly, the following sections would
#  be attempted.
#
#  Note that if any changes are made to the files mentioned above, the comment
#  characters at the beginning of the following lines should be removed.
#  icont must be on your search path for these actions to work.
#
#../common/lextab.h ../common/yacctok.h ../common/fixgram ../common/pscript: \
#			../common/tokens.txt ../common/op.txt
#		cd ../common; $(MAKE) gfiles
#
#cparse.c ctoken.h:	cgram.g ../common/pscript
## expect 218 shift/reduce conflicts
#		yacc -d cgram.g
#		../common/pscript <y.tab.c >cparse.c
#		mv y.tab.h ctoken.h
#		rm -f y.tab.c
#
#cgram.g:	cgrammar.c ../h/define.h ../h/grammar.h \
#			../common/yacctok.h ../common/fixgram
#		$(CC) -E -C cgrammar.c | ../common/fixgram >cgram.g

=== src/icont/Makefile ===
#  Makefile for the Icon translator, icont.

include ../../Makedefs


HFILES =	../h/define.h ../h/config.h ../h/cpuconf.h ../h/gsupport.h \
		   ../h/mproto.h ../h/typedefs.h ../h/cstructs.h

TRANS =		trans.o tcode.o tlex.o lnklist.o tparse.o tsym.o tmem.o tree.o

LINKR =		link.o lglob.o lcode.o llex.o lmem.o lsym.o opcode.o

OBJS =		tunix.o tglobals.o util.o $(TRANS) $(LINKR)

COBJS =		../common/long.o ../common/getopt.o ../common/alloc.o \
		   ../common/filepart.o ../common/strtbl.o ../common/ipp.o \
		   ../common/munix.o



icont:		$(OBJS) $(COBJS)
		$(CC) $(CFLAGS) $(LDFLAGS) -o icont $(OBJS) $(COBJS)
		cp icont ../../bin
		strip ../../bin/icont$(EXE)
		(cd ../../bin; rm -f icon; ln -s icont icon)

$(OBJS):	$(HFILES) tproto.h

$(COBJS):	$(HFILES)
		cd ../common; $(MAKE)

tunix.o:	tglobals.h ../h/version.h
tglobals.o:	tglobals.h
util.o:		tglobals.h tree.h ../h/fdefs.h

# translator files
trans.o:	tglobals.h tsym.h ttoken.h tree.h ../h/version.h ../h/kdefs.h
lnklist.o:	lfile.h
tparse.o:	../h/lexdef.h tglobals.h tsym.h tree.h keyword.h
tcode.o:	tglobals.h tsym.h ttoken.h tree.h
tlex.o:		../h/lexdef.h ../h/parserr.h ttoken.h tree.h ../h/esctab.h \
		   ../common/lextab.h ../common/yylex.h ../common/error.h
tmem.o:		tglobals.h tsym.h tree.h
tree.o:		tree.h
tsym.o:		tglobals.h tsym.h ttoken.h lfile.h keyword.h ../h/kdefs.h

# linker files
$(LINKR):	link.h lfile.h ../h/rt.h ../h/sys.h ../h/monitor.h \
		   ../h/rstructs.h ../h/rmacros.h ../h/rexterns.h

link.o:		tglobals.h hdr.h ../h/header.h
lcode.o:	tglobals.h opcode.h keyword.h ../h/header.h \
			../h/opdefs.h ../h/version.h
lglob.o:	tglobals.h opcode.h ../h/opdefs.h ../h/version.h
llex.o:		tglobals.h opcode.h ../h/opdefs.h
lmem.o:		tglobals.h
lsym.o:		tglobals.h
opcode.o:	opcode.h ../h/opdefs.h

#  hdr.h is always built, to simplify the Makefile,
#  but it is only actually used if BinHeader is define.
hdr.h:		newhdr ixhdr.hdr
		./newhdr -o hdr.h ixhdr.hdr
newhdr:		newhdr.c ../h/define.h ../h/config.h ../h/gsupport.h
		$(CC) $(CFLAGS) $(LDFLAGS) -o newhdr newhdr.c
ixhdr.hdr:	ixhdr.c ../h/define.h ../h/config.h ../h/header.h $(COBJS)
		$(CC) $(CFLAGS) $(LDFLAGS) -o ixhdr.hdr \
			ixhdr.c ../common/alloc.o ../common/munix.o
		strip ixhdr.hdr




#  The following sections are commented out because they do not need to be
#  performed unless changes are made to cgrammar.c, ../h/grammar.h,
#  ../common/tokens.txt, or ../common/op.txt.  Such changes involve
#  modifications to the syntax of Icon and are not part of the installation
#  process. However, if the distribution files are unloaded in a fashion
#  such that their dates are not set properly, the following sections would
#  be attempted.
#
#  Note that if any changes are made to the files mentioned above, the comment
#  characters at the beginning of the following lines should be removed.
#  icont must be on your search path for these actions to work.
#
#../common/lextab.h ../common/yacctok.h ../common/fixgram ../common/pscript: \
#			../common/tokens.txt ../common/op.txt
#		cd ../common; $(MAKE) gfiles
#
#tparse.c ttoken.h:	tgram.g trash ../common/pscript
## expect 218 shift/reduce conflicts
#		yacc -d tgram.g
#		./trash <y.tab.c | ../common/pscript >tparse.c
#		mv y.tab.h ttoken.h
#		rm -f y.tab.c
#
#tgram.g:	tgrammar.c ../h/define.h ../h/grammar.h \
#			../common/yacctok.h ../common/fixgram 
#		$(CC) -E -C tgrammar.c | ../common/fixgram >tgram.g
#
#../h/kdefs.h keyword.h:	../runtime/keyword.r mkkwd
#		./mkkwd <../runtime/keyword.r
#
#trash:		trash.icn
#		icont -s trash.icn
#
#mkkwd:		mkkwd.icn
#		icont -s mkkwd.icn

=== src/preproc/Makefile ===
include ../../Makedefs

POBJS = pout.o pchars.o perr.o pmem.o bldtok.o macro.o preproc.o evaluate.o\
	files.o gettok.o pinit.o

COBJS= ../common/getopt.o ../common/time.o ../common/strtbl.o ../common/alloc.o

ICOBJS=	getopt.o time.o strtbl.o alloc.o

OBJS= $(POBJS) $(COBJS)

DOT_H = preproc.h pproto.h ptoken.h ../h/define.h ../h/config.h\
        ../h/typedefs.h ../h/mproto.h

common:
	cd ../common; $(MAKE) $(ICOBJS)
	$(MAKE) pp

pp: pmain.o $(OBJS)
	$(CC) -o pp pmain.o $(OBJS)

pmain.o:	$(DOT_H)
p_out.o:	$(DOT_H)
pchars.o:	$(DOT_H)
p_err.o:	$(DOT_H)
pmem.o:		$(DOT_H)
pstring.o:	$(DOT_H)
bldtok.o:	$(DOT_H)
macro.o:	$(DOT_H)
preproc.o:	$(DOT_H)
evaluate.o:	$(DOT_H)
files.o:	$(DOT_H)
gettok.o:	$(DOT_H)
p_init.o:	$(DOT_H)

=== src/rtt/Makefile ===
#  Makefile for the Icon run-time translator, rtt,
#  which is used to build the Icon run-time system.

include ../../Makedefs


ROBJS = rttparse.o rttmain.o rttlex.o rttsym.o rttnode.o rttout.o rttmisc.o\
	  rttdb.o rttinlin.o rttilc.o

PP_DIR = ../preproc/
P_DOT_H = $(PP_DIR)preproc.h $(PP_DIR)pproto.h ltoken.h ../h/mproto.h\
        ../h/define.h ../h/config.h ../h/typedefs.h\
        ../h/cstructs.h ../h/cpuconf.h
POBJS = pout.o pchars.o  perr.o pmem.o  bldtok.o macro.o preproc.o\
	evaluate.o files.o gettok.o pinit.o

COBJS = ../common/getopt.o ../common/time.o ../common/filepart.o \
	  ../common/identify.o ../common/strtbl.o ../common/alloc.o \
	  ../common/rtdb.o ../common/munix.o ../common/literals.o

OBJ = $(ROBJS) $(POBJS) $(COBJS)


rtt:	$(OBJ)
	$(CC) $(LDFLAGS) -o rtt $(OBJ)
	cp rtt ../../bin
	strip ../../bin/rtt$(EXE)

library:	$(OBJ)
		rm -rf rtt.a
		ar qc rtt.a $(OBJ)

$(COBJS):
	cd ../common; $(MAKE)

$(ROBJS): rtt.h rtt1.h rttproto.h $(P_DOT_H)

rttdb.o: ../h/version.h
rttparse.o : ../h/gsupport.h ../h/config.h ../h/cstructs.h \
	../h/mproto.h ../h/typedefs.h ../h/cpuconf.h ../h/define.h

pout.o: $(PP_DIR)pout.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)pout.c 

pchars.o: $(PP_DIR)pchars.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)pchars.c 

perr.o: $(PP_DIR)perr.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)perr.c

pmem.o: $(PP_DIR)pmem.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)pmem.c

bldtok.o: $(PP_DIR)bldtok.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)bldtok.c

macro.o: $(PP_DIR)macro.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)macro.c

preproc.o: $(PP_DIR)preproc.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)preproc.c

evaluate.o: $(PP_DIR)evaluate.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)evaluate.c

files.o: $(PP_DIR)files.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)files.c

gettok.o: $(PP_DIR)gettok.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)gettok.c

pinit.o: $(PP_DIR)pinit.c $(P_DOT_H)
	$(CC) -c $(CFLAGS) $(PP_DIR)pinit.c

#
# The following entry is commented out because it is not normally
# necessary to recreate rttparse.c and ltoken.h unless the grammar
# in rttgram.y for the run-time langauge is changed. Recreating these
# files is not normally a part of the installation process. Note that
# on some systems, yacc may not have large enough internal tables to
# translate this grammar.
#
#rttparse.c ltoken.h: rttgram.y
#	yacc -d rttgram.y
#	fgrep -v -x "extern char *malloc(), *realloc();" y.tab.c > rttparse.c
#	rm y.tab.c
#	mv y.tab.h ltoken.h

=== src/runtime/Makefile ===
#  Makefile for the Icon run-time system.

include ../../Makedefs


HDRS = ../h/define.h ../h/config.h ../h/typedefs.h ../h/monitor.h\
	  ../h/cstructs.h ../h/cpuconf.h ../h/grttin.h\
	  ../h/rmacros.h ../h/rexterns.h ../h/rstructs.h \
	  ../h/rproto.h ../h/mproto.h ../h/sys.h

GRAPHICSHDRS = ../h/graphics.h ../h/xwin.h ../h/mswin.h

COBJS =	../common/long.o ../common/time.o \
	../common/rswitch.o ../common/xwindow.o \
	../common/alloc.o ../common/filepart.o ../common/munix.o


default: iconx
all:	 iconx comp_all

$(COBJS):
	cd ../common; $(MAKE)


####################################################################
#
# Make entries for iconx
#

XOBJS =	xcnv.o xdata.o xdef.o xerrmsg.o xextcall.o xfconv.o xfload.o xfmath.o\
	xfmisc.o xfmonitr.o xfscan.o xfstr.o xfstranl.o xfstruct.o xfsys.o\
	xfwindow.o ximain.o ximisc.o xinit.o xinterp.o xinvoke.o\
	xkeyword.o xlmisc.o xoarith.o xoasgn.o xocat.o xocomp.o\
	xomisc.o xoref.o xoset.o xovalue.o xralc.o xrcoexpr.o xrcomp.o\
	xrdebug.o xrlrgint.o xrmemmgt.o xrmisc.o xrstruct.o xrsys.o\
	xrwinrsc.o xrwinsys.o xrwindow.o xrcolor.o xrimage.o

OBJS =	$(XOBJS) $(COBJS)

iconx: $(OBJS)
	cd ../common; $(MAKE)
	$(CC) $(RLINK) -o iconx  $(OBJS) $(XL) $(RLIBS) $(TL)
	cp iconx ../../bin
	strip $(SFLAGS) ../../bin/iconx$(EXE)

xcnv.o: cnv.r $(HDRS)
	../../bin/rtt -x cnv.r
	$(CC) -c $(CFLAGS) xcnv.c
	rm xcnv.c

xdata.o: data.r $(HDRS) ../h/kdefs.h ../h/fdefs.h ../h/odefs.h
	../../bin/rtt -x data.r
	$(CC) -c $(CFLAGS) xdata.c
	rm xdata.c

xdef.o: def.r $(HDRS)
	../../bin/rtt -x def.r
	$(CC) -c $(CFLAGS) xdef.c
	rm xdef.c

xerrmsg.o: errmsg.r $(HDRS)
	../../bin/rtt -x errmsg.r
	$(CC) -c $(CFLAGS) xerrmsg.c
	rm xerrmsg.c

xextcall.o: extcall.r $(HDRS)
	../../bin/rtt -x extcall.r
	$(CC) -c $(CFLAGS) xextcall.c
	rm xextcall.c

xfconv.o: fconv.r $(HDRS)
	../../bin/rtt -x fconv.r
	$(CC) -c $(CFLAGS) xfconv.c
	rm xfconv.c

xfload.o: fload.r $(HDRS)
	../../bin/rtt -x fload.r
	$(CC) -c $(CFLAGS) xfload.c
	rm xfload.c

xfmath.o: fmath.r $(HDRS)
	../../bin/rtt -x fmath.r
	$(CC) -c $(CFLAGS) xfmath.c
	rm xfmath.c

xfmisc.o: fmisc.r $(HDRS)
	../../bin/rtt -x fmisc.r
	$(CC) -c $(CFLAGS) xfmisc.c
	rm xfmisc.c

xfmonitr.o: fmonitr.r $(HDRS)
	../../bin/rtt -x fmonitr.r
	$(CC) -c $(CFLAGS) xfmonitr.c
	rm xfmonitr.c

xfscan.o: fscan.r $(HDRS)
	../../bin/rtt -x fscan.r
	$(CC) -c $(CFLAGS) xfscan.c
	rm xfscan.c

xfstr.o: fstr.r $(HDRS)
	../../bin/rtt -x fstr.r
	$(CC) -c $(CFLAGS) xfstr.c
	rm xfstr.c

xfstranl.o: fstranl.r $(HDRS)
	../../bin/rtt -x fstranl.r
	$(CC) -c $(CFLAGS) xfstranl.c
	rm xfstranl.c

xfstruct.o: fstruct.r $(HDRS)
	../../bin/rtt -x fstruct.r
	$(CC) -c $(CFLAGS) xfstruct.c
	rm xfstruct.c

xfsys.o: fsys.r $(HDRS)
	../../bin/rtt -x fsys.r
	$(CC) -c $(CFLAGS) xfsys.c
	rm xfsys.c

xfwindow.o: fwindow.r $(HDRS) $(GRAPHICSHDRS)
	../../bin/rtt -x fwindow.r
	$(CC) -c $(CFLAGS) xfwindow.c
	rm xfwindow.c

ximain.o: imain.r $(HDRS) ../h/version.h
	../../bin/rtt -x imain.r
	$(CC) -c $(CFLAGS) ximain.c
	rm ximain.c

ximisc.o: imisc.r $(HDRS)
	../../bin/rtt -x imisc.r
	$(CC) -c $(CFLAGS) ximisc.c
	rm ximisc.c

xinit.o: init.r $(HDRS) ../h/odefs.h ../h/version.h
	../../bin/rtt -x init.r
	$(CC) -c $(CFLAGS) xinit.c
	rm xinit.c

xinterp.o: interp.r $(HDRS)
	../../bin/rtt -x interp.r
	$(CC) -c $(CFLAGS) xinterp.c
	rm xinterp.c

xinvoke.o: invoke.r $(HDRS)
	../../bin/rtt -x invoke.r
	$(CC) -c $(CFLAGS) xinvoke.c
	rm xinvoke.c

xkeyword.o: keyword.r $(HDRS) ../h/features.h ../h/version.h
	../../bin/rtt -x keyword.r
	$(CC) -c $(CFLAGS) xkeyword.c
	rm xkeyword.c

xlmisc.o: lmisc.r $(HDRS)
	../../bin/rtt -x lmisc.r
	$(CC) -c $(CFLAGS) xlmisc.c
	rm xlmisc.c

xoarith.o: oarith.r $(HDRS)
	../../bin/rtt -x oarith.r
	$(CC) -c $(CFLAGS) xoarith.c
	rm xoarith.c

xoasgn.o: oasgn.r $(HDRS)
	../../bin/rtt -x oasgn.r
	$(CC) -c $(CFLAGS) xoasgn.c
	rm xoasgn.c

xocat.o: ocat.r $(HDRS)
	../../bin/rtt -x ocat.r
	$(CC) -c $(CFLAGS) xocat.c
	rm xocat.c

xocomp.o: ocomp.r $(HDRS)
	../../bin/rtt -x ocomp.r
	$(CC) -c $(CFLAGS) xocomp.c
	rm xocomp.c

xomisc.o: omisc.r $(HDRS)
	../../bin/rtt -x omisc.r
	$(CC) -c $(CFLAGS) xomisc.c
	rm xomisc.c

xoref.o: oref.r $(HDRS)
	../../bin/rtt -x oref.r
	$(CC) -c $(CFLAGS) xoref.c
	rm xoref.c

xoset.o: oset.r $(HDRS)
	../../bin/rtt -x oset.r
	$(CC) -c $(CFLAGS) xoset.c
	rm xoset.c

xovalue.o: ovalue.r $(HDRS)
	../../bin/rtt -x ovalue.r
	$(CC) -c $(CFLAGS) xovalue.c
	rm xovalue.c

xralc.o: ralc.r $(HDRS)
	../../bin/rtt -x ralc.r
	$(CC) -c $(CFLAGS) xralc.c
	rm xralc.c

xrcoexpr.o: rcoexpr.r $(HDRS)
	../../bin/rtt -x rcoexpr.r
	$(CC) -c $(CFLAGS) xrcoexpr.c
	rm xrcoexpr.c

xrcomp.o: rcomp.r $(HDRS)
	../../bin/rtt -x rcomp.r
	$(CC) -c $(CFLAGS) xrcomp.c
	rm xrcomp.c

xrdebug.o: rdebug.r $(HDRS)
	../../bin/rtt -x rdebug.r
	$(CC) -c $(CFLAGS) xrdebug.c
	rm xrdebug.c

xrlrgint.o: rlrgint.r $(HDRS)
	../../bin/rtt -x rlrgint.r
	$(CC) -c $(CFLAGS) xrlrgint.c
	rm xrlrgint.c

xrmemmgt.o: rmemmgt.r $(HDRS)
	../../bin/rtt -x rmemmgt.r
	$(CC) -c $(CFLAGS) xrmemmgt.c
	rm xrmemmgt.c

xrmisc.o: rmisc.r $(HDRS)
	../../bin/rtt -x rmisc.r
	$(CC) -c $(CFLAGS) xrmisc.c
	rm xrmisc.c

xrstruct.o: rstruct.r $(HDRS)
	../../bin/rtt -x rstruct.r
	$(CC) -c $(CFLAGS) xrstruct.c
	rm xrstruct.c

xrsys.o: rsys.r $(HDRS)
	../../bin/rtt -x rsys.r
	$(CC) -c $(CFLAGS) xrsys.c
	rm xrsys.c

xrwinrsc.o: rwinrsc.r $(HDRS) $(GRAPHICSHDRS) rxrsc.ri
	../../bin/rtt -x rwinrsc.r
	$(CC) -c $(CFLAGS) xrwinrsc.c
	rm xrwinrsc.c

xrwinsys.o: rwinsys.r $(HDRS) $(GRAPHICSHDRS) rxwin.ri
	../../bin/rtt -x rwinsys.r
	$(CC) -c $(CFLAGS) xrwinsys.c
	rm xrwinsys.c

xrwindow.o: rwindow.r $(HDRS) $(GRAPHICSHDRS)
	../../bin/rtt -x rwindow.r
	$(CC) -c $(CFLAGS) xrwindow.c
	rm xrwindow.c

xrcolor.o: rcolor.r $(HDRS) $(GRAPHICSHDRS)
	../../bin/rtt -x rcolor.r
	$(CC) -c $(CFLAGS) xrcolor.c
	rm xrcolor.c

xrimage.o: rimage.r $(HDRS) $(GRAPHICSHDRS)
	../../bin/rtt -x rimage.r
	$(CC) -c $(CFLAGS) xrimage.c
	rm xrimage.c


####################################################################
#
# Make entries for the compiler library
#

comp_all: $(COBJS) db_lib

db_lib: rt.db rt.a

#
# if rt.db is missing or any header files have been updated, recreate
# rt.db from scratch along with the .o files.
#
rt.db: $(HDRS)
	rm -f rt.db rt.a
	../../bin/rtt cnv.r data.r def.r errmsg.r fconv.r fload.r fmath.r\
	  fmisc.r fmonitr.r fscan.r fstr.r fstranl.r fstruct.r\
	  fsys.r fwindow.r init.r invoke.r keyword.r\
	  lmisc.r oarith.r oasgn.r ocat.r ocomp.r omisc.r\
	  oref.r oset.r ovalue.r ralc.r rcoexpr.r rcomp.r\
	  rdebug.r rlrgint.r rmemmgt.r rmisc.r rstruct.r\
	  rsys.r rwinrsc.r rwinsys.r rwindow.r rcolor.r rimage.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

rt.a: ../common/rswitch.o ../common/long.o ../common/time.o\
      cnv.o data.o def.o errmsg.o fconv.o fload.o fmath.o fmisc.o fmonitr.o \
      fscan.o fstr.o fstranl.o fstruct.o fsys.o fwindow.o init.o invoke.o\
      keyword.o lmisc.o oarith.o oasgn.o ocat.o ocomp.o omisc.o oref.o oset.o\
      ovalue.o ralc.o rcoexpr.o rcomp.o rdebug.o rlrgint.o rmemmgt.o\
      rmisc.o rstruct.o rsys.o rwinrsc.o rwinsys.o\
      rwindow.o rcolor.o rimage.o ../common/xwindow.o ../common/alloc.o
	rm -f rt.a
	ar qc rt.a `sed 's/$$/.o/' rttcur.lst` ../common/rswitch.o\
	    ../common/long.o ../common/time.o\
	    ../common/xwindow.o ../common/alloc.o
	ranlib rt.a 2>/dev/null || :
	cp -p rt.a rt.db ../common/dlrgint.o ../../bin

cnv.o: cnv.r $(HDRS)
	../../bin/rtt cnv.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

data.o: data.r $(HDRS)
	../../bin/rtt data.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

def.o: def.r $(HDRS)
	../../bin/rtt def.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

errmsg.o: errmsg.r $(HDRS)
	../../bin/rtt errmsg.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fconv.o: fconv.r $(HDRS)
	../../bin/rtt fconv.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fload.o: fload.r $(HDRS)
	../../bin/rtt fload.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fmath.o: fmath.r $(HDRS)
	../../bin/rtt fmath.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fmisc.o: fmisc.r $(HDRS)
	../../bin/rtt fmisc.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fmonitr.o: fmonitr.r $(HDRS)
	../../bin/rtt fmonitr.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fscan.o: fscan.r $(HDRS)
	../../bin/rtt fscan.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fstr.o: fstr.r $(HDRS)
	../../bin/rtt fstr.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fstranl.o: fstranl.r $(HDRS)
	../../bin/rtt fstranl.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fstruct.o: fstruct.r $(HDRS)
	../../bin/rtt fstruct.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fsys.o: fsys.r $(HDRS)
	../../bin/rtt fsys.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

fwindow.o: fwindow.r $(HDRS) $(GRAPHICSHDRS)
	../../bin/rtt fwindow.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

init.o: init.r $(HDRS)
	../../bin/rtt init.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

invoke.o: invoke.r $(HDRS)
	../../bin/rtt invoke.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

keyword.o: keyword.r $(HDRS)
	../../bin/rtt keyword.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

lmisc.o: lmisc.r $(HDRS)
	../../bin/rtt lmisc.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

oarith.o: oarith.r $(HDRS)
	../../bin/rtt oarith.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

oasgn.o: oasgn.r $(HDRS)
	../../bin/rtt oasgn.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

ocat.o: ocat.r $(HDRS)
	../../bin/rtt ocat.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

ocomp.o: ocomp.r $(HDRS)
	../../bin/rtt ocomp.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

omisc.o: omisc.r $(HDRS)
	../../bin/rtt omisc.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

oref.o: oref.r $(HDRS)
	../../bin/rtt oref.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

oset.o: oset.r $(HDRS)
	../../bin/rtt oset.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

ovalue.o: ovalue.r $(HDRS)
	../../bin/rtt ovalue.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

ralc.o: ralc.r $(HDRS)
	../../bin/rtt ralc.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

rcoexpr.o: rcoexpr.r $(HDRS)
	../../bin/rtt rcoexpr.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

rcomp.o: rcomp.r $(HDRS)
	../../bin/rtt rcomp.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

rdebug.o: rdebug.r $(HDRS)
	../../bin/rtt rdebug.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

rlrgint.o: rlrgint.r $(HDRS)
	../../bin/rtt rlrgint.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

rmemmgt.o: rmemmgt.r $(HDRS)
	../../bin/rtt rmemmgt.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

rmisc.o: rmisc.r $(HDRS)
	../../bin/rtt rmisc.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

rstruct.o: rstruct.r $(HDRS)
	../../bin/rtt rstruct.r
	$(CC) -c $(CFLAGS) `sed 's/$$/.c/' rttcur.lst`
	rm `sed 's/$$/.c/' rttcur.lst`

rsys.o: rsys.r $(HDRS)
	../../bin/rtt rsys.r

=== debian/changelog ===
icon (9.4.3-7) unstable; urgency=medium

  * QA upload.
  * Fix FTBFS with glibc 2.28. Closes: #915334.

 -- Santiago Vila <sanvila@debian.org>  Tue, 11 Dec 2018 22:14:40 +0100

icon (9.4.3-6) unstable; urgency=medium

  * QA upload.
  * Drop outdated manpage debian/icon.1.
  * Use man/man1/icon.1 and man/man1/icont.1 from original tarball.
  * Drop iconc package. It does not work, it is not supported upstream,
    and it does not even exist in version 9.5.1. Closes: #345425.
  * Rename debian/rules targets test-icont and benchmark-icont to
    just test and benchmark.
  * Make /usr/bin/icon a symlink to /usr/bin/icont, fpllowing upstream.
    This should allow writing scripts using #!/usr/bin/icon.

 -- Santiago Vila <sanvila@debian.org>  Thu, 11 Aug 2016 23:29:20 +0200

icon (9.4.3-5) unstable; urgency=medium

  * QA upload.
  * Package is orphaned (Bug #738875), set Maintainer to "Debian QA Group".
  * Do not run the tests as root. This used to make the build to fail on
    the Hurd. It does not anymore, but it's a bug anyway. Closes: #654381.
  * Ack NMUs. This should now build on sparc and mips. Closes: #660466.
  * Add build-arch and build-indep targets to debian/rules. Closes: #821993.
  * Apply patch from Reiner Herrmann to build reproducibly. Closes: #829133.
  * Switch to "3.0 (quilt)" source format.
  * General cleanup of debian/rules.

 -- Santiago Vila <sanvila@debian.org>  Tue, 09 Aug 2016 18:45:08 +0100

icon (9.4.3-4.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Also use -O0 on mips.

 -- Julien Cristau <jcristau@debian.org>  Sat, 23 Mar 2013 13:25:54 +0100

icon (9.4.3-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Restore -O0 on sparc and mipsel.  -O2 causes unaligned accesses, and thus
    crashes in the test suite.

 -- Julien Cristau <jcristau@debian.org>  Fri, 22 Mar 2013 15:22:08 +0000

icon (9.4.3-4) unstable; urgency=medium

  * Apply patch from Aurelien Jarno: instead of disabling all optimizations
    on a special-cased subset of architectures, use -O2 but disable the
    individual optimizations that cause problem. Do this on all architectures.
    Fixes FTBFS (because of test failures) on s390x. (Closes: #638356)

 -- Christian Hudon <chrish@debian.org>  Thu, 05 Jan 2012 14:11:49 -0500

icon (9.4.3-3) unstable; urgency=low

  * Apply patch from Kees Cook so Icon is not built needlessly with an
    executable stack. (Closes: #543450)

 -- Christian Hudon <chrish@debian.org>  Mon, 23 May 2011 15:28:11 -0400

icon (9.4.3-2) unstable; urgency=medium

  * Apply patch from Jurij Smakov to correctly change -O2 to -O0 when building.
    Should build and pass tests on all archs now, including Sparc32
    (Closes: #475952, #420979)

 -- Christian Hudon <chrish@debian.org>  Sun, 17 Aug 2008 19:45:27 -0400

icon (9.4.3-1) unstable; urgency=low

  * New upstream version. (Closes: #339781)
  * Merge NMU changes, except CLK_TCK -> CLOCKS_PER_SEC one, because
    upstream now has a fallback using a sysconfig() call. (Closes:
    #249208, #292864, #293472, #277660, #360180) Will wait to see if this
    builds on all archs before closing bug number 420979.
  * Maintainer back in action. (Closes: #454591)

 -- Christian Hudon <chrish@debian.org>  Sun,  9 Dec 2007 12:37:42 -0500

icon (9.4.2-2.8) unstable; urgency=medium

  * Non-maintainer upload during BSP.
  * Substitute CLK_TCK with CLOCKS_PER_SEC in src/common/time.c (Closes:
    #420979).

 -- Mario Iseli <admin@marioiseli.com>  Thu, 17 May 2007 18:10:20 +0200

icon (9.4.2-2.7) unstable; urgency=low

  * NMU
  * Fixes FTBFS on arm* and ppc64. Closes: #344503, #360180

 -- Riku Voipio <riku.voipio@iki.fi>  Thu, 12 Oct 2006 14:12:30 +0300

icon (9.4.2-2.6) unstable; urgency=low

  * NMU
  * Fix FTBFS on i386 by building with -O0 there. Same as bug #249208
    but for i386 now. Closes: #346188

 -- Joey Hess <joeyh@debian.org>  Sun,  5 Mar 2006 21:08:52 -0500

icon (9.4.2-2.5) unstable; urgency=low

  * Non-maintainer upload
  * Fix debian/rules so that debian/rules succeeds (Closes: #342322)
  * Let iconc not depend on xlibs-dev anymore (Closes: #346188, #347153)

 -- Marc 'HE' Brockschmidt <he@debian.org>  Sat, 21 Jan 2006 16:06:34 +0100

icon (9.4.2-2.4) unstable; urgency=medium

  * NMU
  * Apply patch from Jurij Smakov to work around possible
    gcc bug.  closes: #322972.
  * Bump Standards-Version to 3.6.2.
  * Remove prerm scripts.

 -- Clint Adams <schizo@debian.org>  Mon, 19 Dec 2005 22:48:01 -0500

icon (9.4.2-2.3) unstable; urgency=low

  * Non-maintainer upload during BSP
  * Update debian/rules arch/os selections to current dpkg
    conventions which fixes FTBFS on linux (Closes: #316664)

 -- Frank Lichtenheld <djpig@debian.org>  Sun,  7 Aug 2005 02:46:33 +0200

icon (9.4.2-2.2) unstable; urgency=low

  * Non-maintainer upload during BSP
  * Update config/gnu/Makeconf according to config/linux/Makeconf to
    prevent an infinite loop/system hang. (closes: #292864)
  * Force system to linux for k*BSD when configuring. (closes: #293472)
  * Change Build-Depends from `xlibs-dev' to `libx11-dev, libxt-dev'.
    (closes: #277660)
  * Compile with -O0 on amd64. (closes: #249208)

 -- Michael Banck <mbanck@debian.org>  Sun,  6 Feb 2005 12:00:47 +0100

icon (9.4.2-2.1) unstable; urgency=low

  * Non-maintainer upload during BSP
  * Compile with -O0 on some architectures
    (alpha,hppa,ia64,mips,mipsel,powerpc,s390,sparc)
    I don't know if this fixes all of them but at least
    alpha, ia64, powerpc I have tested to build (see #229394)
  * Add -Wall -g to CFLAGS while we're at it. Obviously nobody
    has ever done this from the output this produces :/
  * Remove debian/postinst as it only sets the usr/doc link

 -- Frank Lichtenheld <djpig@debian.org>  Fri, 19 Mar 2004 13:44:06 +0100

icon (9.4.2-2) unstable; urgency=low

  * Apply patch from Frank Lichtenheld to make icon build on other
    architectures. (Closes: #217655)



=== debian/control ===
Source: icon
Maintainer: Debian QA Group <packages@qa.debian.org>
Standards-Version: 3.6.2
Section: devel
Priority: optional
Build-Depends: libx11-dev, libxt-dev

Package: icont
Architecture: any
Depends: ${shlibs-icont:Depends}
Recommends: iconx
Suggests: icon-ipl
Description: Interpreter for Icon, a high-level programming language
 Ideal for both complex nonnumerical applications and for situations where
 users need quick solutions with a minimum of programming effort, Icon is a
 high-level, general purpose programming language with a syntax similar to
 Pascal and C. Its applications include: rapid prototyping, analyzing
 natural languages, generating computer programs, and artificial
 intelligence. (From the back cover of the book "The Icon Programming
 Language," by Griswold and Griswold.)
 .
 This package contains the Icon translator, which converts Icon source code
 into `ucode` that can then be executed with the help of the iconx program.

Package: iconx
Architecture: any
Depends: ${shlibs-iconx:Depends}
Description: Executor for Icon, a high-level programming language
 Ideal for both complex nonnumerical applications and for situations where
 users need quick solutions with a minimum of programming effort, Icon is a
 high-level, general purpose programming language with a syntax similar to
 Pascal and C. Its applications include: rapid prototyping, analyzing
 natural languages, generating computer programs, and artificial
 intelligence. (From the back cover of the book "The Icon Programming
 Language," by Griswold and Griswold.)
 .
 This package contains the Icon executor, iconx, which is needed to execute
 interpreted Icon programs. If you are starting from Icon source code (as 
 opposed to precompiled `ucode' files), you will also need the icont
 package, which converts your Icon source into a program that iconx can
 execute.

Package: icon-ipl
Architecture: all
Recommends: icont
Description: Libraries for Icon, a high-level programming language
 Ideal for both complex nonnumerical applications and for situations where
 users need quick solutions with a minimum of programming effort, Icon is a
 high-level, general purpose programming language with a syntax similar to
 Pascal and C. Its applications include: rapid prototyping, analyzing
 natural languages, generating computer programs, and artificial
 intelligence. (From the back cover of the book "The Icon Programming
 Language," by Griswold and Griswold.)
 .
 This package contains the Icon program library, a library of Icon
 procedures and programs contributed by Icon users.

=== debian/rules ===
#!/usr/bin/make -f
#
# Do we make rt.a into an ELF library?
# Do we make iconx link with xpm.so?

DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)
DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU 2>/dev/null)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null)

# The current code use type-punning and signed overflow
ifneq (,$(filter $(DEB_HOST_ARCH), sparc mips mipsel))
  CFLAGS_OPT = -O0
else
  CFLAGS_OPT = -O2 -fno-strict-aliasing -fno-strict-overflow
endif

ifneq (, $(filter $(DEB_HOST_ARCH_OS), linux kfreebsd knetbsd))
  system = linux
else
  ifeq ($(DEB_HOST_ARCH_OS),hurd)
    system = gnu
  else
    system = $(DEB_HOST_ARCH_OS)
  endif
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  CFLAGS_OPT = -O0
endif

CFLAGS = -Wall -g $(CFLAGS_OPT)

configure:
	$(MAKE) X-Configure name=$(system)
	sed "s/CFLAGS = .*/CFLAGS = $(CFLAGS)/" Makedefs > Makedefs.tmp
	echo "ASFLAGS = -Wa,--noexecstack" >> Makedefs.tmp
	mv Makedefs.tmp Makedefs
	touch $@

build-icont: configure
	$(MAKE) Icont
	touch $@

build-ipl: configure
	$(MAKE) Ilib
	touch $@

clean:
	rm -f configure build-icont build-ipl
	rm -rf debian/iconx debian/icont debian/icon-ipl debian/files debian/*~
	rm -f bin/* debian/substvars
	$(MAKE) Pure

binary-icont: build-icont
	rm -rf debian/icont
# Create the directory hierarchy.
	install -d debian/icont/usr/bin
	install -d debian/icont/DEBIAN
	install -d debian/icont/usr/share/man/man1
	install -d debian/icont/usr/share/doc/icont
# Copy the executables and documentation...
	install -s -m 755 bin/icont debian/icont/usr/bin
	ln -s icont debian/icont/usr/bin/icon
	install -m 644 man/man1/icon.1 debian/icont/usr/share/man/man1/icon.1
	install -m 644 man/man1/icont.1 debian/icont/usr/share/man/man1/icont.1
	sed -e 's/icon-dir/icont/g' debian/copyright \
		> debian/icont/usr/share/doc/icont/copyright
	install -m 644 debian/changelog \
		debian/icont/usr/share/doc/icont/changelog.Debian
# Patch icont...
#	bin/patchstr debian/icont/usr/bin/icont /usr/bin/iconx
# Wrap icont to provide default for IPATH and LPATH
#	mv debian/icont/usr/bin/icont debian/icont/usr/bin/icont.real
#	install -o root -g root -m 755 debian/icont-wrapper debian/icont/usr/bin/icont
# Compress documentation...
	gzip -9n debian/icont/usr/share/doc/icont/changelog.Debian
	gzip -9rn debian/icont/usr/share/man
#	cd debian/icont/usr/share/man/man1 && ln -sf icont.1.gz icont.real.1.gz
# Fix permissions...
	chmod -R u=rwX,go=rX debian/icont
	chown -R root:root debian/icont
# Make the debian control area.
	dpkg-shlibdeps -pshlibs-icont debian/icont/usr/bin/*
	dpkg-gencontrol -picont -Pdebian/icont
# And finally, build the Debian package!
	dpkg --build debian/icont ..

binary-iconx: build-icont
	rm -rf debian/iconx
# Create the directory hierarchy.
	install -d debian/iconx/usr/bin
	install -d debian/iconx/DEBIAN
	install -d debian/iconx/usr/share/man/man1
	install -d debian/iconx/usr/share/doc/iconx
# Copy the executables and documentation...
	install -s -m 755 bin/iconx debian/iconx/usr/bin
	install -m 644 man/man1/icon.1 debian/iconx/usr/share/man/man1/iconx.1
	sed -e 's/icon-dir/iconx/g' debian/copyright \
		> debian/iconx/usr/share/doc/iconx/copyright
	install -m 644 debian/changelog \
		debian/iconx/usr/share/doc/iconx/changelog.Debian
# Compress documentation...
	gzip -9n debian/iconx/usr/share/doc/iconx/changelog.Debian
	gzip -9rn debian/iconx/usr/share/man
# Fix permissions...
	chmod -R u=rwX,go=rX debian/iconx
	chown -R root:root debian/iconx
# Make the debian control area.
	dpkg-shlibdeps -pshlibs-iconx debian/iconx/usr/bin/*
	dpkg-gencontrol -piconx -Pdebian/iconx
# And finally, build the Debian package!
	dpkg --build debian/iconx ..

binary-ipl: build-ipl
	rm -rf debian/icon-ipl
# Create the directory hierarchy.
	install -d debian/icon-ipl/DEBIAN
	install -d debian/icon-ipl/usr/share/doc/icon-ipl
	install -d debian/icon-ipl/usr/lib/icon-ipl
# Copy Icon program library...
	cp -r lib/* ipl/procs/*.icn ipl/gprocs/*.icn debian/icon-ipl/usr/lib/icon-ipl
# Copy copyright information.
	sed -e 's/icon-dir/icon-ipl/g' debian/copyright \
		> debian/icon-ipl/usr/share/doc/icon-ipl/copyright
	install -m 644 debian/changelog \
		debian/icon-ipl/usr/share/doc/icon-ipl/changelog.Debian
# Compress documentation...
	gzip -9n debian/icon-ipl/usr/share/doc/icon-ipl/changelog.Debian
	find debian/icon-ipl/usr/share/doc/icon-ipl -type f -size +6k -print | \
		xargs --no-run-if-empty gzip -9n
# Fix permissions...
	chmod -R u=rwX,go=rX debian/icon-ipl
	chown -R root:root debian/icon-ipl
# Make the debian control area.
	dpkg-gencontrol -picon-ipl -Pdebian/icon-ipl
# And finally, build the Debian package!
	dpkg --build debian/icon-ipl ..

test: build-icont build-ipl
	@echo Tests for the Icon interpreter.
	@echo First some simple tests to be sure Icon works.
	$(MAKE) Samples-icont
	@echo More exhaustive tests of various features of Icon and larger programs.
	@echo  1. Basic tests. Should show only insignificant differences.
	$(MAKE) Test-icont

benchmark: build-icont
	$(MAKE) Benchmark-icont	

build-arch: build
build-indep: build
build-iconx: build-icont
build: build-icont build-ipl test

binary-arch: binary-icont binary-iconx

binary-indep: binary-ipl

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean build build-arch build-indep test benchmark
